diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/txop.cc ns-3.42/src/wifi/model/txop.cc
--- ns-3.41/src/wifi/model/txop.cc	2024-02-09 14:44:08.597795000 -0800
+++ ns-3.42/src/wifi/model/txop.cc	2024-05-29 15:29:47.208073900 -0700
@@ -25,20 +25,20 @@
 #include "wifi-mac-queue.h"
 #include "wifi-mac-trailer.h"
 #include "wifi-mac.h"
+#include "wifi-phy.h"
 
 #include "ns3/attribute-container.h"
 #include "ns3/log.h"
 #include "ns3/pointer.h"
-#include "ns3/random-variable-stream.h"
+#include "ns3/shuffle.h"
 #include "ns3/simulator.h"
 #include "ns3/socket.h"
 
+#include <iterator>
+#include <sstream>
+
 #undef NS_LOG_APPEND_CONTEXT
-#define NS_LOG_APPEND_CONTEXT                                                                      \
-    if (m_mac)                                                                                     \
-    {                                                                                              \
-        std::clog << "[mac=" << m_mac->GetAddress() << "] ";                                       \
-    }
+#define NS_LOG_APPEND_CONTEXT WIFI_TXOP_NS_LOG_APPEND_CONTEXT
 
 namespace ns3
 {
@@ -55,6 +55,27 @@
             .SetParent<ns3::Object>()
             .SetGroupName("Wifi")
             .AddConstructor<Txop>()
+            .AddAttribute("AcIndex",
+                          "The AC index of the packets contained in the wifi MAC queue of this "
+                          "Txop object.",
+                          EnumValue(AcIndex::AC_UNDEF),
+                          MakeEnumAccessor<AcIndex>(&Txop::CreateQueue),
+                          MakeEnumChecker(AC_BE,
+                                          "AC_BE",
+                                          AC_BK,
+                                          "AC_BK",
+                                          AC_VI,
+                                          "AC_VI",
+                                          AC_VO,
+                                          "AC_VO",
+                                          AC_BE_NQOS,
+                                          "AC_BE_NQOS",
+                                          AC_VI,
+                                          "AC_VI",
+                                          AC_BEACON,
+                                          "AC_BEACON",
+                                          AC_UNDEF,
+                                          "AC_UNDEF"))
             .AddAttribute("MinCw",
                           "The minimum value of the contention window (just for the first link, "
                           "in case of 11be multi-link devices).",
@@ -62,11 +83,16 @@
                           UintegerValue(15),
                           MakeUintegerAccessor((void(Txop::*)(uint32_t)) & Txop::SetMinCw,
                                                (uint32_t(Txop::*)() const) & Txop::GetMinCw),
-                          MakeUintegerChecker<uint32_t>())
+                          MakeUintegerChecker<uint32_t>(),
+                          TypeId::OBSOLETE,
+                          "Use MinCws attribute instead of MinCw")
             .AddAttribute(
                 "MinCws",
-                "The minimum values of the contention window for all the links",
-                TypeId::ATTR_GET | TypeId::ATTR_SET, // do not set at construction time
+                "The minimum values of the contention window for all the links (sorted in "
+                "increasing order of link ID). An empty vector is ignored and the default value "
+                "as per Table 9-155 of the IEEE 802.11-2020 standard will be used. Note that, if "
+                "this is a non-AP STA, these values could be overridden by values advertised by "
+                "the AP through EDCA Parameter Set elements.",
                 AttributeContainerValue<UintegerValue>(),
                 MakeAttributeContainerAccessor<UintegerValue>(&Txop::SetMinCws, &Txop::GetMinCws),
                 MakeAttributeContainerChecker<UintegerValue>(MakeUintegerChecker<uint32_t>()))
@@ -77,11 +103,16 @@
                           UintegerValue(1023),
                           MakeUintegerAccessor((void(Txop::*)(uint32_t)) & Txop::SetMaxCw,
                                                (uint32_t(Txop::*)() const) & Txop::GetMaxCw),
-                          MakeUintegerChecker<uint32_t>())
+                          MakeUintegerChecker<uint32_t>(),
+                          TypeId::OBSOLETE,
+                          "Use MaxCws attribute instead of MaxCw")
             .AddAttribute(
                 "MaxCws",
-                "The maximum values of the contention window for all the links",
-                TypeId::ATTR_GET | TypeId::ATTR_SET, // do not set at construction time
+                "The maximum values of the contention window for all the links (sorted in "
+                "increasing order of link ID). An empty vector is ignored and the default value "
+                "as per Table 9-155 of the IEEE 802.11-2020 standard will be used. Note that, if "
+                "this is a non-AP STA, these values could be overridden by values advertised by "
+                "the AP through EDCA Parameter Set elements.",
                 AttributeContainerValue<UintegerValue>(),
                 MakeAttributeContainerAccessor<UintegerValue>(&Txop::SetMaxCws, &Txop::GetMaxCws),
                 MakeAttributeContainerChecker<UintegerValue>(MakeUintegerChecker<uint32_t>()))
@@ -93,11 +124,16 @@
                 UintegerValue(2),
                 MakeUintegerAccessor((void(Txop::*)(uint8_t)) & Txop::SetAifsn,
                                      (uint8_t(Txop::*)() const) & Txop::GetAifsn),
-                MakeUintegerChecker<uint8_t>())
+                MakeUintegerChecker<uint8_t>(),
+                TypeId::OBSOLETE,
+                "Use Aifsns attribute instead of Aifsn")
             .AddAttribute(
                 "Aifsns",
-                "The values of AIFSN for all the links",
-                TypeId::ATTR_GET | TypeId::ATTR_SET, // do not set at construction time
+                "The values of AIFSN for all the links (sorted in increasing order "
+                "of link ID). An empty vector is ignored and the default value as per "
+                "Table 9-155 of the IEEE 802.11-2020 standard will be used. Note that, if "
+                "this is a non-AP STA, these values could be overridden by values advertised by "
+                "the AP through EDCA Parameter Set elements.",
                 AttributeContainerValue<UintegerValue>(),
                 MakeAttributeContainerAccessor<UintegerValue>(&Txop::SetAifsns, &Txop::GetAifsns),
                 MakeAttributeContainerChecker<UintegerValue>(MakeUintegerChecker<uint8_t>()))
@@ -108,14 +144,20 @@
                           TimeValue(MilliSeconds(0)),
                           MakeTimeAccessor((void(Txop::*)(Time)) & Txop::SetTxopLimit,
                                            (Time(Txop::*)() const) & Txop::GetTxopLimit),
-                          MakeTimeChecker())
-            .AddAttribute("TxopLimits",
-                          "The values of TXOP limit for all the links",
-                          TypeId::ATTR_GET | TypeId::ATTR_SET, // do not set at construction time
-                          AttributeContainerValue<TimeValue>(),
-                          MakeAttributeContainerAccessor<TimeValue>(&Txop::SetTxopLimits,
-                                                                    &Txop::GetTxopLimits),
-                          MakeAttributeContainerChecker<TimeValue>(MakeTimeChecker()))
+                          MakeTimeChecker(),
+                          TypeId::OBSOLETE,
+                          "Use TxopLimits attribute instead of TxopLimit")
+            .AddAttribute(
+                "TxopLimits",
+                "The values of TXOP limit for all the links (sorted in increasing order "
+                "of link ID). An empty vector is ignored and the default value as per "
+                "Table 9-155 of the IEEE 802.11-2020 standard will be used. Note that, if "
+                "this is a non-AP STA, these values could be overridden by values advertised by "
+                "the AP through EDCA Parameter Set elements.",
+                AttributeContainerValue<TimeValue>(),
+                MakeAttributeContainerAccessor<TimeValue>(&Txop::SetTxopLimits,
+                                                          &Txop::GetTxopLimits),
+                MakeAttributeContainerChecker<TimeValue>(MakeTimeChecker()))
             .AddAttribute("Queue",
                           "The WifiMacQueue object",
                           PointerValue(),
@@ -133,15 +175,9 @@
 }
 
 Txop::Txop()
-    : Txop(CreateObject<WifiMacQueue>(AC_BE_NQOS))
-{
-}
-
-Txop::Txop(Ptr<WifiMacQueue> queue)
-    : m_queue(queue)
 {
     NS_LOG_FUNCTION(this);
-    m_rng = CreateObject<UniformRandomVariable>();
+    m_rng = m_shuffleLinkIdsGen.GetRv();
 }
 
 Txop::~Txop()
@@ -160,6 +196,14 @@
     m_links.clear();
 }
 
+void
+Txop::CreateQueue(AcIndex aci)
+{
+    NS_LOG_FUNCTION(this << aci);
+    NS_ABORT_MSG_IF(m_queue, "Wifi MAC queue can only be created once");
+    m_queue = CreateObject<WifiMacQueue>(aci);
+}
+
 std::unique_ptr<Txop::LinkEntity>
 Txop::CreateLinkEntity() const
 {
@@ -240,9 +284,20 @@
 }
 
 void
-Txop::SetMinCws(std::vector<uint32_t> minCws)
+Txop::SetMinCws(const std::vector<uint32_t>& minCws)
 {
-    NS_ABORT_IF(minCws.size() != m_links.size());
+    if (minCws.empty())
+    {
+        // an empty vector is passed to use the default values specified by the standard
+        return;
+    }
+
+    NS_ABORT_MSG_IF(!m_links.empty() && minCws.size() != m_links.size(),
+                    "The size of the given vector (" << minCws.size()
+                                                     << ") does not match the number of links ("
+                                                     << m_links.size() << ")");
+    m_userAccessParams.cwMins = minCws;
+
     std::size_t i = 0;
     for (const auto& [id, link] : m_links)
     {
@@ -253,7 +308,9 @@
 void
 Txop::SetMinCw(uint32_t minCw, uint8_t linkId)
 {
-    NS_LOG_FUNCTION(this << minCw << +linkId);
+    NS_LOG_FUNCTION(this << minCw << linkId);
+    NS_ASSERT_MSG(!m_links.empty(),
+                  "This function can only be called after that links have been created");
     auto& link = GetLink(linkId);
     bool changed = (link.cwMin != minCw);
     link.cwMin = minCw;
@@ -270,9 +327,20 @@
 }
 
 void
-Txop::SetMaxCws(std::vector<uint32_t> maxCws)
+Txop::SetMaxCws(const std::vector<uint32_t>& maxCws)
 {
-    NS_ABORT_IF(maxCws.size() != m_links.size());
+    if (maxCws.empty())
+    {
+        // an empty vector is passed to use the default values specified by the standard
+        return;
+    }
+
+    NS_ABORT_MSG_IF(!m_links.empty() && maxCws.size() != m_links.size(),
+                    "The size of the given vector (" << maxCws.size()
+                                                     << ") does not match the number of links ("
+                                                     << m_links.size() << ")");
+    m_userAccessParams.cwMaxs = maxCws;
+
     std::size_t i = 0;
     for (const auto& [id, link] : m_links)
     {
@@ -283,7 +351,9 @@
 void
 Txop::SetMaxCw(uint32_t maxCw, uint8_t linkId)
 {
-    NS_LOG_FUNCTION(this << maxCw << +linkId);
+    NS_LOG_FUNCTION(this << maxCw << linkId);
+    NS_ASSERT_MSG(!m_links.empty(),
+                  "This function can only be called after that links have been created");
     auto& link = GetLink(linkId);
     bool changed = (link.cwMax != maxCw);
     link.cwMax = maxCw;
@@ -302,7 +372,7 @@
 void
 Txop::ResetCw(uint8_t linkId)
 {
-    NS_LOG_FUNCTION(this);
+    NS_LOG_FUNCTION(this << linkId);
     auto& link = GetLink(linkId);
     link.cw = GetMinCw(linkId);
     m_cwTrace(link.cw, linkId);
@@ -311,7 +381,7 @@
 void
 Txop::UpdateFailedCw(uint8_t linkId)
 {
-    NS_LOG_FUNCTION(this);
+    NS_LOG_FUNCTION(this << linkId);
     auto& link = GetLink(linkId);
     // see 802.11-2012, section 9.19.2.5
     link.cw = std::min(2 * (link.cw + 1) - 1, GetMaxCw(linkId));
@@ -335,7 +405,7 @@
 void
 Txop::UpdateBackoffSlotsNow(uint32_t nSlots, Time backoffUpdateBound, uint8_t linkId)
 {
-    NS_LOG_FUNCTION(this << nSlots << backoffUpdateBound << +linkId);
+    NS_LOG_FUNCTION(this << nSlots << backoffUpdateBound << linkId);
     auto& link = GetLink(linkId);
 
     link.backoffSlots -= nSlots;
@@ -346,7 +416,7 @@
 void
 Txop::StartBackoffNow(uint32_t nSlots, uint8_t linkId)
 {
-    NS_LOG_FUNCTION(this << nSlots << +linkId);
+    NS_LOG_FUNCTION(this << nSlots << linkId);
     auto& link = GetLink(linkId);
 
     if (link.backoffSlots != 0)
@@ -368,9 +438,20 @@
 }
 
 void
-Txop::SetAifsns(std::vector<uint8_t> aifsns)
+Txop::SetAifsns(const std::vector<uint8_t>& aifsns)
 {
-    NS_ABORT_IF(aifsns.size() != m_links.size());
+    if (aifsns.empty())
+    {
+        // an empty vector is passed to use the default values specified by the standard
+        return;
+    }
+
+    NS_ABORT_MSG_IF(!m_links.empty() && aifsns.size() != m_links.size(),
+                    "The size of the given vector (" << aifsns.size()
+                                                     << ") does not match the number of links ("
+                                                     << m_links.size() << ")");
+    m_userAccessParams.aifsns = aifsns;
+
     std::size_t i = 0;
     for (const auto& [id, link] : m_links)
     {
@@ -381,7 +462,9 @@
 void
 Txop::SetAifsn(uint8_t aifsn, uint8_t linkId)
 {
-    NS_LOG_FUNCTION(this << +aifsn << +linkId);
+    NS_LOG_FUNCTION(this << aifsn << linkId);
+    NS_ASSERT_MSG(!m_links.empty(),
+                  "This function can only be called after that links have been created");
     GetLink(linkId).aifsn = aifsn;
 }
 
@@ -394,10 +477,18 @@
 void
 Txop::SetTxopLimits(const std::vector<Time>& txopLimits)
 {
-    NS_ABORT_MSG_IF(txopLimits.size() != m_links.size(),
+    if (txopLimits.empty())
+    {
+        // an empty vector is passed to use the default values specified by the standard
+        return;
+    }
+
+    NS_ABORT_MSG_IF(!m_links.empty() && txopLimits.size() != m_links.size(),
                     "The size of the given vector (" << txopLimits.size()
                                                      << ") does not match the number of links ("
                                                      << m_links.size() << ")");
+    m_userAccessParams.txopLimits = txopLimits;
+
     std::size_t i = 0;
     for (const auto& [id, link] : m_links)
     {
@@ -408,12 +499,21 @@
 void
 Txop::SetTxopLimit(Time txopLimit, uint8_t linkId)
 {
-    NS_LOG_FUNCTION(this << txopLimit << +linkId);
+    NS_LOG_FUNCTION(this << txopLimit << linkId);
+    NS_ASSERT_MSG(txopLimit.IsPositive(), "TXOP limit cannot be negative");
     NS_ASSERT_MSG((txopLimit.GetMicroSeconds() % 32 == 0),
                   "The TXOP limit must be expressed in multiple of 32 microseconds!");
+    NS_ASSERT_MSG(!m_links.empty(),
+                  "This function can only be called after that links have been created");
     GetLink(linkId).txopLimit = txopLimit;
 }
 
+const Txop::UserDefinedAccessParams&
+Txop::GetUserAccessParams() const
+{
+    return m_userAccessParams;
+}
+
 uint32_t
 Txop::GetMinCw() const
 {
@@ -515,7 +615,7 @@
 {
     m_queue->WipeAllExpiredMpdus();
     bool ret = static_cast<bool>(m_queue->Peek(linkId));
-    NS_LOG_FUNCTION(this << +linkId << ret);
+    NS_LOG_FUNCTION(this << linkId << ret);
     return ret;
 }
 
@@ -533,30 +633,61 @@
 Txop::Queue(Ptr<WifiMpdu> mpdu)
 {
     NS_LOG_FUNCTION(this << *mpdu);
-    const auto linkIds = m_mac->GetMacQueueScheduler()->GetLinkIds(m_queue->GetAc(), mpdu);
-    std::map<uint8_t, bool> hasFramesToTransmit;
+
+    // channel access can be requested on a blocked link, if the reason for blocking the link
+    // is temporary
+    auto linkIds = m_mac->GetMacQueueScheduler()->GetLinkIds(
+        m_queue->GetAc(),
+        mpdu,
+        {WifiQueueBlockedReason::USING_OTHER_EMLSR_LINK,
+         WifiQueueBlockedReason::WAITING_EMLSR_TRANSITION_DELAY});
+
+    // ignore the links for which a channel access request event is already running
+    for (auto it = linkIds.begin(); it != linkIds.end();)
+    {
+        if (const auto& event = GetLink(*it).accessRequest.event; event.IsPending())
+        {
+            it = linkIds.erase(it);
+        }
+        else
+        {
+            ++it;
+        }
+    }
 
     // save the status of the AC queues before enqueuing the MPDU (required to determine if
     // backoff is needed)
+    std::map<uint8_t, bool> hasFramesToTransmit;
     for (const auto linkId : linkIds)
     {
         hasFramesToTransmit[linkId] = HasFramesToTransmit(linkId);
     }
     m_queue->Enqueue(mpdu);
-    for (const auto linkId : linkIds)
+
+    // shuffle link IDs not to request channel access on links always in the same order
+    std::vector<uint8_t> shuffledLinkIds(linkIds.cbegin(), linkIds.cend());
+    Shuffle(shuffledLinkIds.begin(), shuffledLinkIds.end(), m_shuffleLinkIdsGen.GetRv());
+
+    if (!linkIds.empty() && g_log.IsEnabled(ns3::LOG_DEBUG))
+    {
+        std::stringstream ss;
+        std::copy(shuffledLinkIds.cbegin(),
+                  shuffledLinkIds.cend(),
+                  std::ostream_iterator<uint16_t>(ss, " "));
+        NS_LOG_DEBUG("Request channel access on link IDs: " << ss.str());
+    }
+
+    for (const auto linkId : shuffledLinkIds)
     {
         // schedule a call to StartAccessIfNeeded() to request channel access after that all the
         // packets of a burst have been enqueued, instead of requesting channel access right after
         // the first packet. The call to StartAccessIfNeeded() is scheduled only after the first
         // packet
-        if (auto& event = GetLink(linkId).accessRequest.event; !event.IsRunning())
-        {
-            event = Simulator::ScheduleNow(&Txop::StartAccessAfterEvent,
-                                           this,
-                                           linkId,
-                                           hasFramesToTransmit.at(linkId),
-                                           CHECK_MEDIUM_BUSY);
-        }
+        GetLink(linkId).accessRequest.event = Simulator::ScheduleNow(&Txop::StartAccessAfterEvent,
+                                                                     this,
+                                                                     linkId,
+                                                                     hasFramesToTransmit.at(linkId),
+                                                                     CHECK_MEDIUM_BUSY);
     }
 }
 
@@ -571,11 +702,23 @@
 void
 Txop::StartAccessAfterEvent(uint8_t linkId, bool hadFramesToTransmit, bool checkMediumBusy)
 {
-    NS_LOG_FUNCTION(this << +linkId << hadFramesToTransmit << checkMediumBusy);
+    NS_LOG_FUNCTION(this << linkId << hadFramesToTransmit << checkMediumBusy);
+
+    if (!m_mac->GetWifiPhy(linkId))
+    {
+        NS_LOG_DEBUG("No PHY operating on link " << +linkId);
+        return;
+    }
+
+    if (GetLink(linkId).access != NOT_REQUESTED)
+    {
+        NS_LOG_DEBUG("Channel access already requested or granted on link " << +linkId);
+        return;
+    }
 
-    if (GetLink(linkId).access != NOT_REQUESTED || !HasFramesToTransmit(linkId))
+    if (!HasFramesToTransmit(linkId))
     {
-        NS_LOG_DEBUG("No need to request channel access on link " << +linkId);
+        NS_LOG_DEBUG("No frames to transmit on link " << +linkId);
         return;
     }
 
@@ -609,21 +752,21 @@
 void
 Txop::NotifyAccessRequested(uint8_t linkId)
 {
-    NS_LOG_FUNCTION(this << +linkId);
+    NS_LOG_FUNCTION(this << linkId);
     GetLink(linkId).access = REQUESTED;
 }
 
 void
 Txop::NotifyChannelAccessed(uint8_t linkId, Time txopDuration)
 {
-    NS_LOG_FUNCTION(this << +linkId << txopDuration);
+    NS_LOG_FUNCTION(this << linkId << txopDuration);
     GetLink(linkId).access = GRANTED;
 }
 
 void
 Txop::NotifyChannelReleased(uint8_t linkId)
 {
-    NS_LOG_FUNCTION(this << +linkId);
+    NS_LOG_FUNCTION(this << linkId);
     GetLink(linkId).access = NOT_REQUESTED;
     GenerateBackoff(linkId);
     if (HasFramesToTransmit(linkId))
@@ -635,7 +778,7 @@
 void
 Txop::RequestAccess(uint8_t linkId)
 {
-    NS_LOG_FUNCTION(this << +linkId);
+    NS_LOG_FUNCTION(this << linkId);
     if (GetLink(linkId).access == NOT_REQUESTED)
     {
         m_mac->GetChannelAccessManager(linkId)->RequestAccess(this);
@@ -645,8 +788,8 @@
 void
 Txop::GenerateBackoff(uint8_t linkId)
 {
-    NS_LOG_FUNCTION(this << +linkId);
     uint32_t backoff = m_rng->GetInteger(0, GetCw(linkId));
+    NS_LOG_FUNCTION(this << linkId << backoff);
     m_backoffTrace(backoff, linkId);
     StartBackoffNow(backoff, linkId);
 }
@@ -654,7 +797,7 @@
 void
 Txop::NotifySleep(uint8_t linkId)
 {
-    NS_LOG_FUNCTION(this << +linkId);
+    NS_LOG_FUNCTION(this << linkId);
 }
 
 void
@@ -667,7 +810,7 @@
 void
 Txop::NotifyWakeUp(uint8_t linkId)
 {
-    NS_LOG_FUNCTION(this << +linkId);
+    NS_LOG_FUNCTION(this << linkId);
     // before wake up, no packet can be transmitted
     StartAccessAfterEvent(linkId, DIDNT_HAVE_FRAMES_TO_TRANSMIT, DONT_CHECK_MEDIUM_BUSY);
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/txop.h ns-3.42/src/wifi/model/txop.h
--- ns-3.41/src/wifi/model/txop.h	2024-02-09 14:44:08.597795000 -0800
+++ ns-3.42/src/wifi/model/txop.h	2024-05-29 15:29:47.208073900 -0700
@@ -25,11 +25,18 @@
 #include "ns3/nstime.h"
 #include "ns3/object.h"
 #include "ns3/traced-value.h"
+#include "ns3/uniform-random-bit-generator.h"
 
 #include <map>
 #include <memory>
 #include <vector>
 
+#define WIFI_TXOP_NS_LOG_APPEND_CONTEXT                                                            \
+    if (m_mac)                                                                                     \
+    {                                                                                              \
+        std::clog << "[mac=" << m_mac->GetAddress() << "] ";                                       \
+    }
+
 class EmlsrUlTxopTest;
 
 namespace ns3
@@ -44,6 +51,7 @@
 class UniformRandomVariable;
 class CtrlBAckResponseHeader;
 class WifiMac;
+enum AcIndex : uint8_t;           // opaque enum declaration
 enum WifiMacDropReason : uint8_t; // opaque enum declaration
 
 /**
@@ -74,14 +82,6 @@
 {
   public:
     Txop();
-
-    /**
-     * Constructor
-     *
-     * \param queue the wifi MAC queue
-     */
-    Txop(Ptr<WifiMacQueue> queue);
-
     ~Txop() override;
 
     /**
@@ -146,14 +146,16 @@
     void SetMinCw(uint32_t minCw);
     /**
      * Set the minimum contention window size for each link.
-     * Note that the size of <i>minCws</i> must match the number
+     * Note that an empty <i>minCws</i> is ignored, otherwise its size must match the number
      * of links.
      *
-     * \param minCws the minimum contention window size values.
+     * \param minCws the minimum contention window size for each link (links are sorted in
+     *               increasing order of link ID).
      */
-    void SetMinCws(std::vector<uint32_t> minCws);
+    void SetMinCws(const std::vector<uint32_t>& minCws);
     /**
-     * Set the minimum contention window size for the given link.
+     * Set the minimum contention window size for the given link. Note that this function can
+     * only be called after that links have been created.
      *
      * \param minCw the minimum contention window size.
      * \param linkId the ID of the given link
@@ -168,14 +170,16 @@
     void SetMaxCw(uint32_t maxCw);
     /**
      * Set the maximum contention window size for each link.
-     * Note that the size of <i>maxCws</i> must match the number
+     * Note that an empty <i>maxCws</i> is ignored, otherwise its size must match the number
      * of links.
      *
-     * \param maxCws the maximum contention window size values.
+     * \param maxCws the maximum contention window size for each link (links are sorted in
+     *               increasing order of link ID).
      */
-    void SetMaxCws(std::vector<uint32_t> maxCws);
+    void SetMaxCws(const std::vector<uint32_t>& maxCws);
     /**
-     * Set the maximum contention window size for the given link.
+     * Set the maximum contention window size for the given link. Note that this function can
+     * only be called after that links have been created.
      *
      * \param maxCw the maximum contention window size.
      * \param linkId the ID of the given link
@@ -190,14 +194,16 @@
     void SetAifsn(uint8_t aifsn);
     /**
      * Set the number of slots that make up an AIFS for each link.
-     * Note that the size of <i>aifsns</i> must match the number
+     * Note that an empty <i>aifsns</i> is ignored, otherwise its size must match the number
      * of links.
      *
-     * \param aifsns the number of slots that make up an AIFS for each link.
+     * \param aifsns the number of slots that make up an AIFS for each link (links are sorted in
+     *               increasing order of link ID).
      */
-    void SetAifsns(std::vector<uint8_t> aifsns);
+    void SetAifsns(const std::vector<uint8_t>& aifsns);
     /**
-     * Set the number of slots that make up an AIFS for the given link.
+     * Set the number of slots that make up an AIFS for the given link. Note that this function
+     * can only be called after that links have been created.
      *
      * \param aifsn the number of slots that make up an AIFS.
      * \param linkId the ID of the given link
@@ -212,17 +218,18 @@
     void SetTxopLimit(Time txopLimit);
     /**
      * Set the TXOP limit for each link.
-     * Note that the size of <i>txopLimits</i> must match the number
+     * Note that an empty <i>txopLimits</i> is ignored, otherwise its size must match the number
      * of links.
      *
-     * \param txopLimits the TXOP limit for each link.
+     * \param txopLimits the TXOP limit for each link (links are sorted in increasing order of
+     *                   link ID).
      */
     void SetTxopLimits(const std::vector<Time>& txopLimits);
     /**
-     * Set the TXOP limit for the given link.
+     * Set the TXOP limit for the given link. Note that this function can only be called after
+     * that links have been created.
      *
-     * \param txopLimit the TXOP limit.
-     *        Value zero corresponds to default Txop.
+     * \param txopLimit the TXOP limit (must not be negative)
      * \param linkId the ID of the given link
      */
     void SetTxopLimit(Time txopLimit, uint8_t linkId);
@@ -447,6 +454,25 @@
      */
     void SwapLinks(std::map<uint8_t, uint8_t> links);
 
+    /**
+     * DCF/EDCA access parameters for all the links provided by users via this class' attributes
+     * or the corresponding setter methods. For each access parameter, values are sorted in
+     * increasing order of link ID. If user provides access parameters, they are used by WifiMac
+     * instead of the default values specified by Table 9-155 of 802.11-2020.
+     */
+    struct UserDefinedAccessParams
+    {
+        std::vector<uint32_t> cwMins; //!< the minimum contention window values for all the links
+        std::vector<uint32_t> cwMaxs; //!< the maximum contention window values for all the links
+        std::vector<uint8_t> aifsns;  //!< the AIFSN values for all the links
+        std::vector<Time> txopLimits; //!< TXOP limit values for all the links
+    };
+
+    /**
+     * \return a const reference to user-provided access parameters
+     */
+    const UserDefinedAccessParams& GetUserAccessParams() const;
+
   protected:
     ///< ChannelAccessManager associated class
     friend class ChannelAccessManager;
@@ -455,6 +481,13 @@
     void DoDispose() override;
     void DoInitialize() override;
 
+    /**
+     * Create a wifi MAC queue containing packets of the given AC
+     *
+     * \param aci the index of the given AC
+     */
+    virtual void CreateQueue(AcIndex aci);
+
     /* Txop notifications forwarded here */
     /**
      * Notify that access request has been received for the given link.
@@ -549,11 +582,12 @@
      */
     const std::map<uint8_t, std::unique_ptr<LinkEntity>>& GetLinks() const;
 
-    DroppedMpdu m_droppedMpduCallback; //!< the dropped MPDU callback
-    Ptr<WifiMacQueue> m_queue;         //!< the wifi MAC queue
-    Ptr<MacTxMiddle> m_txMiddle;       //!< the MacTxMiddle
-    Ptr<WifiMac> m_mac;                //!< the wifi MAC
-    Ptr<UniformRandomVariable> m_rng;  //!< the random stream
+    DroppedMpdu m_droppedMpduCallback;             //!< the dropped MPDU callback
+    Ptr<WifiMacQueue> m_queue;                     //!< the wifi MAC queue
+    Ptr<MacTxMiddle> m_txMiddle;                   //!< the MacTxMiddle
+    Ptr<WifiMac> m_mac;                            //!< the wifi MAC
+    Ptr<UniformRandomVariable> m_rng;              //!< the random stream
+    UniformRandomBitGenerator m_shuffleLinkIdsGen; //!< random number generator to shuffle link IDs
 
     /// TracedCallback for backoff trace value typedef
     typedef TracedCallback<uint32_t /* value */, uint8_t /* linkId */> BackoffValueTracedCallback;
@@ -573,6 +607,8 @@
 
     std::map<uint8_t, std::unique_ptr<LinkEntity>>
         m_links; //!< ID-indexed map of LinkEntity objects
+
+    UserDefinedAccessParams m_userAccessParams; //!< user-defined DCF/EDCA access parameters
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/vht/vht-frame-exchange-manager.cc ns-3.42/src/wifi/model/vht/vht-frame-exchange-manager.cc
--- ns-3.41/src/wifi/model/vht/vht-frame-exchange-manager.cc	2024-02-09 14:44:08.597795000 -0800
+++ ns-3.42/src/wifi/model/vht/vht-frame-exchange-manager.cc	2024-05-29 15:29:47.208073900 -0700
@@ -23,7 +23,7 @@
 #include "ns3/log.h"
 
 #undef NS_LOG_APPEND_CONTEXT
-#define NS_LOG_APPEND_CONTEXT std::clog << "[link=" << +m_linkId << "][mac=" << m_self << "] "
+#define NS_LOG_APPEND_CONTEXT WIFI_FEM_NS_LOG_APPEND_CONTEXT
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/vht/vht-phy.cc ns-3.42/src/wifi/model/vht/vht-phy.cc
--- ns-3.41/src/wifi/model/vht/vht-phy.cc	2024-02-09 14:44:08.597795000 -0800
+++ ns-3.42/src/wifi/model/vht/vht-phy.cc	2024-05-29 15:29:47.208073900 -0700
@@ -31,6 +31,9 @@
 #include "ns3/wifi-psdu.h"
 #include "ns3/wifi-utils.h"
 
+#undef NS_LOG_APPEND_CONTEXT
+#define NS_LOG_APPEND_CONTEXT WIFI_PHY_NS_LOG_APPEND_CONTEXT(m_wifiPhy)
+
 namespace ns3
 {
 
@@ -583,8 +586,6 @@
 PhyEntity::CcaIndication
 VhtPhy::GetCcaIndication(const Ptr<const WifiPpdu> ppdu)
 {
-    NS_LOG_FUNCTION(this);
-
     if (m_wifiPhy->GetChannelWidth() < 80)
     {
         return HtPhy::GetCcaIndication(ppdu);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/wifi-acknowledgment.cc ns-3.42/src/wifi/model/wifi-acknowledgment.cc
--- ns-3.41/src/wifi/model/wifi-acknowledgment.cc	2024-02-09 14:44:08.601795200 -0800
+++ ns-3.42/src/wifi/model/wifi-acknowledgment.cc	2024-05-29 15:29:47.208073900 -0700
@@ -31,8 +31,7 @@
  */
 
 WifiAcknowledgment::WifiAcknowledgment(Method m)
-    : method(m),
-      acknowledgmentTime(Time::Min()) // uninitialized
+    : method(m)
 {
 }
 
